
===============================================================
egads_aflr4 RELEASE NOTES: 05/04/25 RELEASE VERSION 2.35.1
===============================================================

Enhancements/ Additions:
------------------------

* Added minimum spacing limit option.

* Added setting geometry evaluation tolerance.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.

===============================================================
egads_aflr4 RELEASE NOTES: 11/27/24 RELEASE VERSION 2.34.9
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised parameters and
  processes for curvature refinement and mesh spacing.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.

===============================================================
egads_aflr4 RELEASE NOTES: 10/23/24 RELEASE VERSION 2.34.6
===============================================================

Enhancements/ Additions:
------------------------

* Replaced degenerate curve error bypass with a true error.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
egads_aflr4 RELEASE NOTES: 10/23/24 RELEASE VERSION 2.34.6
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.26.

* Added option to compile as egads_aflr4_lite for use with EGADS Lite.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
egads_aflr4 RELEASE NOTES: 09/26/24 RELEASE VERSION 2.33.11
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.25.

* Added option to minimize geometry related output.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR4 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
egads_aflr4 RELEASE NOTES: 04/13/24 RELEASE VERSION 2.33.10
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.24.

* Added multi-zone capability for matching edges that differ in
  defined direction.

Bugs Fixed:
-----------

* Revised all loop related maps to account for special case
  duplicated loops with a face-loop sense of +/-2.

* Corrected a loop direction sense for special case duplicated
  loops with a face-loop sense of +/-2.

* Corrected a memory allocation issue.

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
egads_aflr4 RELEASE NOTES: 08/14/23 RELEASE VERSION 2.33.6
===============================================================

Enhancements/ Additions:
------------------------

* Added multi-zone capability for cases with multiple bodies
  and matching faces with curvature.

* Reduced duplicate node uv coordinate matching tolerance.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
egads_aflr4 RELEASE NOTES: 06/21/23 RELEASE VERSION 2.33.3
===============================================================

Enhancements/ Additions:
------------------------

* Added multi-zone capability for cases with multiple bodies
  and matching faces.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
egads_aflr4 RELEASE NOTES: 04/20/23 RELEASE VERSION 2.32.2
===============================================================

Enhancements/ Additions:
------------------------

* Initial implementation of multi-zone capability.
  To be completed in the near future.

Bugs Fixed:
-----------

* 

Known Issues:
-------------

* An invalid Tess object can be created after AFLR3 in cases
  with transparent surfaces that are connected together.
  To be corrected in the near future.

===============================================================
egads_aflr4 RELEASE NOTES: 03/28/23 RELEASE VERSION 2.31.7
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.23.

* Minor internal code changes.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 12/01/22 RELEASE VERSION 2.31.5
===============================================================

Enhancements/ Additions:
------------------------

* Added AFLR4 input parameter for local quad-face combination flag.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 11/20/22 RELEASE VERSION 2.31.4
===============================================================

Enhancements/ Additions:
------------------------

* Changed all sprintf calls to snprintf.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 11/11/22 RELEASE VERSION 2.31.3
===============================================================

Enhancements/ Additions:
------------------------

* Added global and local quad-face combination flag attributes.

* Changes for compatibility with quad-face conversion to
  tria-faces.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 08/03/22 RELEASE VERSION 2.30.5
===============================================================

Enhancements/ Additions:
------------------------

* Added check and correction for consistent boundary edge
  ordering within egads_aflr4_get_bedge_coord.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 07/25/22 RELEASE VERSION 2.30.3
===============================================================

Enhancements/ Additions:
------------------------

* Increased tolerance used to locate Nodes at ends of Edges for
  Tess creation. This prevents failure during processing Edges
  that bound very-high-aspect-ratio Faces.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 07/18/22 RELEASE VERSION 2.30.2
===============================================================

Enhancements/ Additions:
------------------------

* Modified Tess creation from AFLR3 data to skip all Bodies
  that include a Face with the grid BC set to Transparent Source.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 07/14/22 RELEASE VERSION 2.30.1
===============================================================

Enhancements/ Additions:
------------------------

* Updated to EGADS v1.21.

* Changes to allow tess creation from AFLR3 with transparent BCs
  that are deleted at completion by AFLR3. This applies to BCs
  TRANSP_SRC_UG3_GBC and TRANSP_INTRNL_UG3_GBC. Note that with
  this change all points on a TRANSP_SRC_UG3_GBC will be insereted.
  Previously AFLR3 only inserted those that were in the domain
  and not too close to other boundary faces.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 06/25/22 RELEASE VERSION 2.29.3
===============================================================

Enhancements/ Additions:
------------------------

* Added capability in tess creation for singular points where
  three or more internal or periodic edges intersect.

Bugs Fixed:
-----------

* Fixed issue in tess creation with periodic edges.

===============================================================
egads_aflr4 RELEASE NOTES: 06/10/22 RELEASE VERSION 2.28.26
===============================================================

Enhancements/ Additions:
------------------------

* Changed name of egads_aflr4_get_tess to egads_aflr4_create_tess.

* Added egads_aflr4_tess_to_dgeom routine to update surface mesh
  support data in the DGEOM data structure using an existing Tess.

* Added routine egads_aflr4_tess_to_surf to create and save
  surface mesh data from an EGADS model with tessellation objects.

* Add support for deriving EGADS tess data from AFLR3 volume mesh
  data with multi-use edges and multi-use nodes.

* Cleanup changes for interactive use.

* Removed automatic reset to off of option to set FF grid BC.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 10/14/21 RELEASE VERSION 2.26.5
===============================================================

Enhancements/ Additions:
------------------------

* Added support of DGEOM modified evaluation routines for
  evaluating uv at xyz with capability to use an estimate to
  improve accuracy and efficiency.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 09/30/21 RELEASE VERSION 2.25.6
===============================================================

Enhancements/ Additions:
------------------------

* Add support for DGEOM & AFLR4 edge data.

* Add support for deriving EGADS tess data from AFLR3 volume mesh
  data.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 07/02/21 RELEASE VERSION 2.24.1
===============================================================

Enhancements/ Additions:
------------------------

* Added EGADS inverse evaluation uv at xyz.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 06/11/21 RELEASE VERSION 2.23.1
===============================================================

Enhancements/ Additions:
------------------------

* Modified EGADS tess creation and setting.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 05/21/21 RELEASE VERSION 2.22.5
===============================================================

Enhancements/ Additions:
------------------------

* Added maps for EGADS face, loop, edge and node connectivity
  and data.

* Added capability to edit the input surface definition with
  surface definitions specified to either keep or remove.

* Added capability for EGADS effective surface definitions.

* Modified edge scale factor to allow it to be larger than 1
  and increase edge spacing.

* Removed Effective Body processing in egads_cad_geom_file_read.

* Added Effective Body processing in egads_set_ext_cad_data.

* Restored API for egads_set_ext_cad_data to original form with
  only the EGADS model as input.

* Modified the process for creating and evaluating an EGADS Tess from
  the output surface mesh generated by AFLR4.

* Removed check_tess and added mmsg arguments to API for
  egads_aflr4_get_tess.

Bugs Fixed:
-----------

* Corrected issue with indexing when setting the edge scale factor
  from command line arguments.

* Corrected memory issue when adding a FarField box.

* Corrected UV normalization issue in evaluating the EGADS Tess.

* Corrected issue evaluating the EGADS Tess with Effective Topology.

===============================================================
egads_aflr4 RELEASE NOTES: 02/08/21 RELEASE VERSION 2.20.10
===============================================================

Enhancements/ Additions:
------------------------

* Added edge scale factor attribute with label
  AFLR4_Scale_Factor.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 12/08/20 RELEASE VERSION 2.19.1
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with AFLR4.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 09/22/20 RELEASE VERSION 2.18.9
===============================================================

Enhancements/ Additions:
------------------------

* Added attributes to control the isolated edge refinement.
  The EGADS attributes are AFLR4_mier (global isolated edge
  refinement flag) and AFLR4_Isolated_Edge_Refinement_Flag
  (individual surface isolated edge refinement flag).

* Separated out farfield add-on and auto BC setting options
  from initial geometry setup.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 08/12/20 RELEASE VERSION 2.17.18
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with revised DGEOM, SURF_AUTO_CPP,
  and AFLR4 libraries.

* Added setup of DGEOM data structure for global parameters.

* Modified setting of EGADS attributes.

* Added setting of all attributes to the output EGADS geometry
  file.

* Added automatic setting of transparent grid BC if a surface
  has a free edge.

* Added option to automatically set the farfield grid BC on the
  outermost closed body by setting the parameter option
  auto_set_ff_bc (which is on by default).

Bugs Fixed:
-----------

* Corrected an issue determine edge-face and face neighbor maps.

* Corrected and simplified farfield spacing calculation.

* Corrected an issue in setting geometry face neighbors.

===============================================================
egads_aflr4 RELEASE NOTES: 06/08/20 RELEASE VERSION 2.15.7
===============================================================

Enhancements/ Additions:
------------------------

* Modified slightly farfield spacing calculation.

* Update include files to EGADS 1.18.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 05/16/20 RELEASE VERSION 2.15.5
===============================================================

Enhancements/ Additions:
------------------------

* Added Grid BC check along with routines for Edge-Face map and
  list of Faces attached to a Face.

* Added setting the Grid BC to standard surface (STD_UG3_GBC)
  using the new input parameter std_ids.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 04/18/20 RELEASE VERSION 2.14.18
===============================================================

Enhancements/ Additions:
------------------------

* Added capability to estimate the BL thickness based on Reynolds
  Number. A new AFLR4 parameter named Re_l was added to set Reynolds
  Number. A corresponding EGADS attribute named AFLR4_Re_l was
  also added.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 04/08/20 RELEASE VERSION 2.14.13
===============================================================

Enhancements/ Additions:
------------------------

* Modified process for determining farfield point spacing. The
  new process includes overall domain size, inner body size,
  reference length and field growth rate and results in improved
  determination of farfield spacing. The old parameter ff_nseg
  is no longer used or available. Instead, the primary user
  control on farfield spacing is a new parameter that controls
  the field spacing growth rate, ff_cdfr. The default value is
  1.2 and the farfield spacing varies linearly when the value
  of ff_cdfr is changed.

* Update include files to EGADS 1.17.

* Changes for compatibility.

* Added capability to add overall AFLR4 parameters to the EGADS
  data as attributes attached to the model.

* Added capability to add a rectangular or square box farfield
  geometry and add it to the EGADS data structure.

* Added capability to write new EGADS data file with attributes
  that may be new and/or farfield box that may be added.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 07/29/19 RELEASE VERSION 2.11.1
===============================================================

Enhancements/ Additions:
------------------------

* Added a lower and upper limit to uv values for evaluation of
  curvature. This is to compensate for an issue in the underlying
  derivatives from Open Cascade that EGADS uses to calculate 
  curvature. For some surfaces their is a singularity in the
  derivative that causes erroneous curvature values at the
  uv boundaries of the surface definition. The input parameter
  uv_curv_lim provides a limit on how close to the actual boundary
  curvature can be evaluated (uv_curv_lim < uv < 1-uv_curv_lim).

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 07/03/19 RELEASE VERSION 2.10.6
===============================================================

Enhancements/ Additions:
------------------------

* Added edge arc length evaluation routine egads_eval_arclen.

Bugs Fixed:
-----------

* Added missing parameter free statement in egads_aflr4_get_tess.

* Corrected memory leak in egads_aflr4_check_tess.

===============================================================
egads_aflr4 RELEASE NOTES: 05/30/19 RELEASE VERSION 2.9.5
===============================================================

Enhancements/ Additions:
------------------------

* Separated routine egads_aflr4_get_tess into three routines;
  egads_aflr4_check_tess, egads_aflr4_get_tess, and 
  egads_aflr4_set_tess_ordering.

* Added check option to egads_aflr4_get_tess API and created
  an alternative API for AFLR4 testing.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 05/28/19 RELEASE VERSION 2.8.2
===============================================================

Enhancements/ Additions:
------------------------

* Added parameter to set all EGADS Attributes to default value
  for AFLR4.

* Added coordinate checking to egads_aflr4_get_tess routine.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 05/08/19 RELEASE VERSION 2.7.17
===============================================================

Enhancements/ Additions:
------------------------

* Modified setting of EGADS attributes.

* Added complete description of EGADS attributes to routine
  egads_cad_geom_setup.c.
  

Bugs Fixed:
-----------

* Corrected indexing error in egads_aflr4_get_tess.

===============================================================
egads_aflr4 RELEASE NOTES: 01/24/19 RELEASE VERSION 2.6.13
===============================================================

Enhancements/ Additions:
------------------------

* Modified most all routines to use EGADS bodies as primary data
  source and removed dependence on EGADS model data.

* Modifications for compatibility with CAPS interface routines.

* Added routine egads_aflr4_get_tess to get surface mesh in tess
  data form from AFLR4 dgeom_def data.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 12/11/18 RELEASE VERSION 2.5.7
===============================================================

Enhancements/ Additions:
------------------------

* Modified egads_auto_cad_geom_setup for clarity.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 11/28/18 RELEASE VERSION 2.5.5
===============================================================

Enhancements/ Additions:
------------------------

* Added edge mesh spacing scale factor for each surface. This
  allows the spacing on edges of a given surface to be modified
  based on the level of discontinuity between neighboring surfaces
  that share an edge.

* Added global edge mesh spacing scale factor option.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 11/09/18 RELEASE VERSION 2.4.15
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility with the new surf_auto and
  surf_auto_cpp libs that replace the dcurv, egen_auto and
  surfgen libs.

Bugs Fixed:
-----------

* 

===============================================================
egads_aflr4 RELEASE NOTES: 11/06/18 RELEASE VERSION 2.4.12
===============================================================

Enhancements/ Additions:
------------------------

* Moved EGADS system include files egads.h, egadsErrors.h, and
  egadsTypes.h to directory egads_include.

* Added check if EGADS_INCLUDE_DIR is set and if it includes the
  EGADS system include files then that directory is used instead
  of egads_include. NOTE: This check is included in both
  egads_aflr4.compile_lib and aflr4/aflr4.compile.

* Added routine egads_cad_geom_file_cleanup to free all EGADS CAD
  geometry file related array space and close any open files.

Bugs Fixed:
-----------

* Changed ug_free calls to the correct EGADS EG_free calls.

===============================================================
egads_aflr4 RELEASE NOTES: 10/26/18 RELEASE VERSION 2.4.9
===============================================================

Enhancements/ Additions:
------------------------

* Added capability to specify a mesh size scaling factor on each
  CAD surface.

* Moved cleanup of EGADS model and context pointers to a separate
  routine.

Bugs Fixed:
-----------

*

===============================================================
egads_aflr4 RELEASE NOTES: 10/21/18 RELEASE VERSION 2.2.11
===============================================================

Enhancements/ Additions:
------------------------

* Moved reading of EGADS CAD data file to a separate routine
  and allow egads_cad_geom_setup to operate directly from an
  EGADS model in memory.

* Added support of multiple-bodies within EGADS models.

* Added transparent surface capability.

Bugs Fixed:
-----------

*

===============================================================
egads_aflr4 RELEASE NOTES: 09/05/18 RELEASE VERSION 2.1.7
===============================================================

Enhancements/ Additions:
------------------------

* Changes for compatibility.

* Added EGADS Attributes to store AFLR4 run parameters. The AFLR4 executable
  version adds these to the input EGADS data file. In integrated form it is
  expected that the integrator create the appropriate routine to add the same.

* Added EGADS function to determine surface curvature.

Bugs Fixed:
-----------

*

===============================================================
egads_aflr4 RELEASE NOTES: 08/01/18 RELEASE VERSION 1.1.1
===============================================================

Enhancements/ Additions:
------------------------

* Created EGADS_AFLR4_LIB with routines to handle EGADS CAD geometry data for
  AFLR4. These routines were in aflr4/main/ and were only included in the
  AFLR4 executable program. They are now a separate library.

Bugs Fixed:
-----------

*

